# from logs_conf.logger import *
from logs.logger import *
import pandas as pd


class SuctionWithLiquidMultiComp(object):
    def __init__(self, dict_chiller_inner, dict_upper_correct):
        self.dict_chiller_inner = dict_chiller_inner
        self.dict_upper_correct = dict_upper_correct
        self.data_general = pd.DataFrame()

    def judge_suction_with_liquid(self, load_ratio):
        """
        根据负载率和等熵效率判断是否是吸气带液
        :param load_ratio: 压缩机负载率，若只有一个机头则为机组负载率
        :return:
        """
        judge_suction_with_liquid = 0
        if (max(self.data_general['iseEfficiency']) - min(self.data_general['iseEfficiency']) > 0.5) \
                and (self.data_general['iseEfficiency'].iloc[-1] > 0.85) and load_ratio > 30:  # 第一个条件是最大值和最小值，已修改
            judge_suction_with_liquid = 1
        return judge_suction_with_liquid

    @staticmethod
    def is_suction_with_liquid(list_ise_efficiency, list_suction_with_liquid):
        """

        :param list_ise_efficiency:
        :param list_suction_with_liquid:
        :return:
        """
        is_suction_with_liquid = 0
        list_ise_efficiency_liquid = []
        ise_efficiency_liquid = ''
        for i in range(len(list_ise_efficiency)):
            if list_suction_with_liquid[i] == 1:
                list_ise_efficiency_liquid.append(list_ise_efficiency[i][-1])
                is_suction_with_liquid = 1
        if list_ise_efficiency_liquid:
            ise_efficiency_liquid = max(list_ise_efficiency_liquid)
        return is_suction_with_liquid, ise_efficiency_liquid

    def temp_set_adjust(self, ise_efficiency_liquid):
        """
        根据最大等熵效率的范围判断带液程度，确定吸气带液情况下的水温设定值
        :param ise_efficiency_liquid:
        :return:
        """
        if 0.85 < ise_efficiency_liquid < 1:
            if self.dict_chiller_inner['runMode'] == 0:
                water_temp_set_new = self.dict_chiller_inner['chillerWaterTempOut'][-1] - \
                                     ise_efficiency_liquid
            elif self.dict_chiller_inner['runMode'] == 1:
                water_temp_set_new = self.dict_chiller_inner['coolingWaterTempOut'][-1] + \
                                     ise_efficiency_liquid      # 此处有修改
            else:
                water_temp_set_new = ''
                logger.critical('============冷机运行模式输入错误============')
            results_depict = '压缩机出现带液，水温下调'
        else:
            if self.dict_chiller_inner['runMode'] == 0:
                water_temp_set_new = self.dict_chiller_inner['chillerWaterTempOut'][-1] - 1.0
            elif self.dict_chiller_inner['runMode'] == 1:
                water_temp_set_new = self.dict_chiller_inner['coolingWaterTempOut'][-1] + 1.0   # 此处有修改
            else:
                water_temp_set_new = ''
                logger.critical('============冷机运行模式输入错误============')
            results_depict = '压缩机严重带液，水温下调'
        logger.critical('============%s============' % results_depict)
        return water_temp_set_new, results_depict




