# from logs_conf.logger import *
from logs.logger import *
import math


class ModifyLeavingWaterTempSetTSS05(object):
    def __init__(self, water_temp_set_new, dict_chiller_inner):
        self.water_temp_set_new = water_temp_set_new
        self.dict_chiller_inner = dict_chiller_inner

    def modify_temp(self):
        if self.dict_chiller_inner['runMode'] == 0:
            result = self.modify_temp_cooling()
        elif self.dict_chiller_inner['runMode'] == 1:
            result = self.modify_temp_heating()
        else:
            result = ''
            logger.critical('============冷机运行模式输入错误============')
        return result

    def modify_temp_cooling(self):
        if self.water_temp_set_new > self.dict_chiller_inner['chillerWaterTempSet']:
            result = self.increase_temp_cooling()
        else:
            result = self.decrease_temp_cooling()
        return result

    def modify_temp_heating(self):
        if self.water_temp_set_new < self.dict_chiller_inner['coolingWaterTempOut']:
            result = self.decrease_temp_heating()
        else:
            result = self.increase_temp_heating()
        return result

    def increase_temp_cooling(self):
        tempDiff = round(self.water_temp_set_new - math.floor(self.water_temp_set_new), 2)
        if tempDiff > 0.5:  # 以0.5为步长的向上取值
            modify_water_temp_set = math.floor(self.water_temp_set_new) + 1.0
        else:
            modify_water_temp_set = math.floor(self.water_temp_set_new) + 0.5
        if modify_water_temp_set - self.dict_chiller_inner['chillerWaterTempOut'][-1] > \
                0.75 * self.dict_chiller_inner['coolingShutdownOffset']:
            deltaWaterTempSet = round((modify_water_temp_set - 0.5) - self.dict_chiller_inner['chillerWaterTempSet'], 2)
            if deltaWaterTempSet >= 1.0:
                result = self.dict_chiller_inner['chillerWaterTempSet'] + 1.0
            elif deltaWaterTempSet >= 0.5:
                result = self.dict_chiller_inner['chillerWaterTempSet'] + 0.5
            else:
                result = self.dict_chiller_inner['chillerWaterTempSet']
        else:
            deltaWaterTempSet = round(self.water_temp_set_new - self.dict_chiller_inner['chillerWaterTempSet'], 2)
            if deltaWaterTempSet >= 1.0:
                result = self.dict_chiller_inner['chillerWaterTempSet'] + 1.0
            elif self.water_temp_set_new < 10 and deltaWaterTempSet > 0.1:
                result = modify_water_temp_set
            else:
                if deltaWaterTempSet >= 0.7:
                    result = self.dict_chiller_inner['chillerWaterTempSet'] + 1.0
                elif deltaWaterTempSet >= 0.2:
                    result = self.dict_chiller_inner['chillerWaterTempSet'] + 0.5
                else:
                    result = self.dict_chiller_inner['chillerWaterTempSet']
        return result

    def decrease_temp_cooling(self):
        deltaWaterTempSet = round(self.water_temp_set_new - self.dict_chiller_inner['chillerWaterTempSet'], 2)
        if abs(deltaWaterTempSet) >= 1:
            fractionalPart = abs(deltaWaterTempSet) % 1
            if fractionalPart >= 0.7:
                result = self.dict_chiller_inner['chillerWaterTempSet'] - (math.floor(abs(deltaWaterTempSet)) + 1.0)
            elif fractionalPart >= 0.2:
                result = self.dict_chiller_inner['chillerWaterTempSet'] - (math.floor(abs(deltaWaterTempSet)) + 0.5)
            else:
                result = self.dict_chiller_inner['chillerWaterTempSet'] - math.floor(abs(deltaWaterTempSet))
        elif abs(deltaWaterTempSet) >= 0.7:
            result = self.dict_chiller_inner['chillerWaterTempSet'] - 1.0
        elif abs(deltaWaterTempSet) >= 0.2:
            result = self.dict_chiller_inner['chillerWaterTempSet'] - 0.5
        else:
            result = self.dict_chiller_inner['chillerWaterTempSet']
        return result

    def increase_temp_heating(self):
        deltaWaterTempSet = round(self.dict_chiller_inner['coolingWaterTempOut'] - self.water_temp_set_new, 2)
        if abs(deltaWaterTempSet) >= 1:
            fractionalPart = abs(deltaWaterTempSet) % 1
            if fractionalPart >= 0.7:
                result = self.dict_chiller_inner['coolingWaterTempOut'] + (math.floor(abs(deltaWaterTempSet)) + 1.0)
            elif fractionalPart >= 0.2:
                result = self.dict_chiller_inner['coolingWaterTempOut'] + (math.floor(abs(deltaWaterTempSet)) + 0.5)
            else:
                result = self.dict_chiller_inner['coolingWaterTempOut'] + math.floor(abs(deltaWaterTempSet))
        elif abs(deltaWaterTempSet) >= 0.7:
            result = math.floor(self.water_temp_set_new) + 1.0
        elif abs(deltaWaterTempSet) >= 0.2:
            result = math.floor(self.water_temp_set_new) + 0.5
        else:
            result = math.floor(self.water_temp_set_new)
        return result

    def decrease_temp_heating(self):
        tempDiff = round(self.water_temp_set_new - math.floor(self.water_temp_set_new), 2)
        if tempDiff > 0.5:  # 以0.5为步长的向下取值
            modify_water_temp_set = math.floor(self.water_temp_set_new) + 0.5
        else:
            modify_water_temp_set = math.floor(self.water_temp_set_new)
        if self.dict_chiller_inner['coolingWaterTempOut'] - modify_water_temp_set > \
                0.75 * self.dict_chiller_inner['heatingShutdownOffset']:
            deltaWaterTempSet = round(self.dict_chiller_inner['coolingWaterTempOut'] - (modify_water_temp_set + 0.5), 2)
            if deltaWaterTempSet >= 1.0:
                result = self.dict_chiller_inner['coolingWaterTempOut'] - 1.0
            elif deltaWaterTempSet >= 0.5:
                result = self.dict_chiller_inner['coolingWaterTempOut'] - 0.5
            else:
                result = self.dict_chiller_inner['coolingWaterTempOut']
        else:
            deltaWaterTempSet = round(self.dict_chiller_inner['coolingWaterTempOut'] - self.water_temp_set_new, 2)
            if deltaWaterTempSet >= 1.0:
                result = self.dict_chiller_inner['coolingWaterTempOut'] - 1.0
            elif self.water_temp_set_new > 50 and deltaWaterTempSet > 0.1:
                result = modify_water_temp_set
            else:
                if deltaWaterTempSet >= 0.7:
                    result = self.dict_chiller_inner['coolingWaterTempOut'] - 1.0
                elif deltaWaterTempSet >= 0.2:
                    result = self.dict_chiller_inner['coolingWaterTempOut'] - 0.5
                else:
                    result = self.dict_chiller_inner['coolingWaterTempOut']
        return result


class ModifyReturningWaterTempSetTSS05(object):
    def __init__(self, water_temp_set_new, dict_chiller_inner):
        self.water_temp_set_new = water_temp_set_new
        self.dict_chiller_inner = dict_chiller_inner

    def modify_temp(self):
        if self.dict_chiller_inner['runMode'] == 0:
            result = self.modify_temp_cooling()
        elif self.dict_chiller_inner['runMode'] == 1:
            result = ''
            logger.critical('============制热模式和回水温度控制模式下温度修正函数未开发, Error: TSS05============')
        else:
            result = ''
            logger.critical('============冷机运行模式输入错误============')
        return result

    def modify_temp_cooling(self):
        if self.water_temp_set_new > self.dict_chiller_inner['chillerWaterTempInSet']:
            result = self.increase_temp_cooling()
        else:
            result = self.decrease_temp_cooling()
        return result

    def increase_temp_cooling(self):
        tempDiff = round(self.water_temp_set_new - math.floor(self.water_temp_set_new), 2)
        if tempDiff > 0.5:  # 以0.5为步长的向上取值
            modify_water_temp_set = math.floor(self.water_temp_set_new) + 1.0
        else:
            modify_water_temp_set = math.floor(self.water_temp_set_new) + 0.5
        if modify_water_temp_set - self.dict_chiller_inner['chillerWaterTempIn'][-1] > \
                0.75 * self.dict_chiller_inner['coolingShutdownOffset']:
            deltaWaterTempSet = round((modify_water_temp_set - 0.5) - self.dict_chiller_inner['chillerWaterTempInSet'], 2)
            if deltaWaterTempSet >= 1.0:
                result = self.dict_chiller_inner['chillerWaterTempInSet'] + 1.0
            elif deltaWaterTempSet >= 0.5:
                result = self.dict_chiller_inner['chillerWaterTempInSet'] + 0.5
            else:
                result = self.dict_chiller_inner['chillerWaterTempInSet']
        else:
            deltaWaterTempSet = round(self.water_temp_set_new - self.dict_chiller_inner['chillerWaterTempInSet'], 2)
            if deltaWaterTempSet >= 1.0:
                result = self.dict_chiller_inner['chillerWaterTempInSet'] + 1.0
            elif self.water_temp_set_new < 10 and deltaWaterTempSet > 0.1:
                result = modify_water_temp_set
            else:
                if deltaWaterTempSet >= 0.7:
                    result = self.dict_chiller_inner['chillerWaterTempInSet'] + 1.0
                elif deltaWaterTempSet >= 0.2:
                    result = self.dict_chiller_inner['chillerWaterTempInSet'] + 0.5
                else:
                    result = self.dict_chiller_inner['chillerWaterTempInSet']
        return result

    def decrease_temp_cooling(self):
        deltaWaterTempSet = round(self.water_temp_set_new - self.dict_chiller_inner['chillerWaterTempInSet'], 2)
        if abs(deltaWaterTempSet) >= 1:
            fractionalPart = abs(deltaWaterTempSet) % 1
            if fractionalPart >= 0.7:
                result = self.dict_chiller_inner['chillerWaterTempInSet'] - (math.floor(abs(deltaWaterTempSet)) + 1.0)
            elif fractionalPart >= 0.2:
                result = self.dict_chiller_inner['chillerWaterTempInSet'] - (math.floor(abs(deltaWaterTempSet)) + 0.5)
            else:
                result = self.dict_chiller_inner['chillerWaterTempInSet'] - math.floor(abs(deltaWaterTempSet))
        elif abs(deltaWaterTempSet) >= 0.7:
            result = self.dict_chiller_inner['chillerWaterTempInSet'] - 1.0
        elif abs(deltaWaterTempSet) >= 0.2:
            result = self.dict_chiller_inner['chillerWaterTempInSet'] - 0.5
        else:
            result = self.dict_chiller_inner['chillerWaterTempInSet']
        return result
